
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ProjectsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const projects = await db.projects.create(
            {
                id: data.id || undefined,
        
        name_ar: data.name_ar
        ||
        null
            ,
            
        slug: data.slug
        ||
        null
            ,
            
        project_scope: data.project_scope
        ||
        null
            ,
            
        location_ar: data.location_ar
        ||
        null
            ,
            
        summary_ar: data.summary_ar
        ||
        null
            ,
            
        description_ar: data.description_ar
        ||
        null
            ,
            
        started_at: data.started_at
        ||
        null
            ,
            
        completed_at: data.completed_at
        ||
        null
            ,
            
        is_featured: data.is_featured
        ||
        false
        
            ,
            
        is_published: data.is_published
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        

        
        await projects.setStones_used(data.stones_used || [], {
            transaction,
        });
        
        await projects.setApplications(data.applications || [], {
            transaction,
        });
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.projects.getTableName(),
                belongsToColumn: 'before_images',
                belongsToId: projects.id,
            },
            data.before_images,
            options,
        );
        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.projects.getTableName(),
                belongsToColumn: 'after_images',
                belongsToId: projects.id,
            },
            data.after_images,
            options,
        );
        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.projects.getTableName(),
                belongsToColumn: 'gallery_images',
                belongsToId: projects.id,
            },
            data.gallery_images,
            options,
        );
        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.projects.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: projects.id,
            },
            data.attachments,
            options,
        );
        

        return projects;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const projectsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name_ar: item.name_ar
            ||
            null
            ,
            
                slug: item.slug
            ||
            null
            ,
            
                project_scope: item.project_scope
            ||
            null
            ,
            
                location_ar: item.location_ar
            ||
            null
            ,
            
                summary_ar: item.summary_ar
            ||
            null
            ,
            
                description_ar: item.description_ar
            ||
            null
            ,
            
                started_at: item.started_at
            ||
            null
            ,
            
                completed_at: item.completed_at
            ||
            null
            ,
            
                is_featured: item.is_featured
            ||
            false
        
            ,
            
                is_published: item.is_published
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const projects = await db.projects.bulkCreate(projectsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < projects.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.projects.getTableName(),
                    belongsToColumn: 'before_images',
                    belongsToId: projects[i].id,
                },
                data[i].before_images,
                options,
            );
        }
        
        for (let i = 0; i < projects.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.projects.getTableName(),
                    belongsToColumn: 'after_images',
                    belongsToId: projects[i].id,
                },
                data[i].after_images,
                options,
            );
        }
        
        for (let i = 0; i < projects.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.projects.getTableName(),
                    belongsToColumn: 'gallery_images',
                    belongsToId: projects[i].id,
                },
                data[i].gallery_images,
                options,
            );
        }
        
        for (let i = 0; i < projects.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.projects.getTableName(),
                    belongsToColumn: 'attachments',
                    belongsToId: projects[i].id,
                },
                data[i].attachments,
                options,
            );
        }
        

        return projects;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const projects = await db.projects.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name_ar !== undefined) updatePayload.name_ar = data.name_ar;
        
        
        if (data.slug !== undefined) updatePayload.slug = data.slug;
        
        
        if (data.project_scope !== undefined) updatePayload.project_scope = data.project_scope;
        
        
        if (data.location_ar !== undefined) updatePayload.location_ar = data.location_ar;
        
        
        if (data.summary_ar !== undefined) updatePayload.summary_ar = data.summary_ar;
        
        
        if (data.description_ar !== undefined) updatePayload.description_ar = data.description_ar;
        
        
        if (data.started_at !== undefined) updatePayload.started_at = data.started_at;
        
        
        if (data.completed_at !== undefined) updatePayload.completed_at = data.completed_at;
        
        
        if (data.is_featured !== undefined) updatePayload.is_featured = data.is_featured;
        
        
        if (data.is_published !== undefined) updatePayload.is_published = data.is_published;
        
        
        updatePayload.updatedById = currentUser.id;

        await projects.update(updatePayload, {transaction});

        
        

        
        
        if (data.stones_used !== undefined) {
            await projects.setStones_used(data.stones_used, { transaction });
        }
        
        if (data.applications !== undefined) {
            await projects.setApplications(data.applications, { transaction });
        }
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.projects.getTableName(),
                belongsToColumn: 'before_images',
                belongsToId: projects.id,
            },
            data.before_images,
            options,
        );
        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.projects.getTableName(),
                belongsToColumn: 'after_images',
                belongsToId: projects.id,
            },
            data.after_images,
            options,
        );
        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.projects.getTableName(),
                belongsToColumn: 'gallery_images',
                belongsToId: projects.id,
            },
            data.gallery_images,
            options,
        );
        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.projects.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: projects.id,
            },
            data.attachments,
            options,
        );
        

        return projects;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const projects = await db.projects.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of projects) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of projects) {
                await record.destroy({transaction});
            }
        });


        return projects;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const projects = await db.projects.findByPk(id, options);

        await projects.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await projects.destroy({
            transaction
        });

        return projects;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const projects = await db.projects.findOne(
            { where },
            { transaction },
        );

        if (!projects) {
            return projects;
        }

        const output = projects.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.project_media_project = await projects.getProject_media_project({
            transaction
        });
        
        
        
        
        
        output.lead_requests_related_project = await projects.getLead_requests_related_project({
            transaction
        });
        
        
        
        
        
        
        
        output.stones_used = await projects.getStones_used({
            transaction
        });
        
        
        output.applications = await projects.getApplications({
            transaction
        });
        
        
        output.before_images = await projects.getBefore_images({
            transaction
        });
        
        
        output.after_images = await projects.getAfter_images({
            transaction
        });
        
        
        output.gallery_images = await projects.getGallery_images({
            transaction
        });
        
        
        output.attachments = await projects.getAttachments({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [


      {
        model: db.stones,
        as: 'stones_used',
        required: false,
      },

      {
        model: db.applications,
        as: 'applications',
        required: false,
      },


      {
        model: db.file,
        as: 'before_images',
      },

      {
        model: db.file,
        as: 'after_images',
      },

      {
        model: db.file,
        as: 'gallery_images',
      },

      {
        model: db.file,
        as: 'attachments',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name_ar) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'projects',
                        'name_ar',
                        filter.name_ar,
                    ),
                };
            }
            
            if (filter.slug) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'projects',
                        'slug',
                        filter.slug,
                    ),
                };
            }
            
            if (filter.location_ar) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'projects',
                        'location_ar',
                        filter.location_ar,
                    ),
                };
            }
            
            if (filter.summary_ar) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'projects',
                        'summary_ar',
                        filter.summary_ar,
                    ),
                };
            }
            
            if (filter.description_ar) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'projects',
                        'description_ar',
                        filter.description_ar,
                    ),
                };
            }
            

            
            
            if (filter.calendarStart && filter.calendarEnd) {
                where = {
                    ...where,
                    [Op.or]: [
                        {
                            started_at: {
                                [Op.between]: [filter.calendarStart, filter.calendarEnd],
                            },
                    },
                {
                    completed_at: {
                        [Op.between]: [filter.calendarStart, filter.calendarEnd],
                    },
                },
                ],
            };
            }
            

            
            if (filter.started_atRange) {
                const [start, end] = filter.started_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    started_at: {
                    ...where.started_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    started_at: {
                    ...where.started_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.completed_atRange) {
                const [start, end] = filter.completed_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    completed_at: {
                    ...where.completed_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    completed_at: {
                    ...where.completed_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.project_scope) {
                where = {
                    ...where,
                project_scope: filter.project_scope,
            };
            }
            
            if (filter.is_featured) {
                where = {
                    ...where,
                is_featured: filter.is_featured,
            };
            }
            
            if (filter.is_published) {
                where = {
                    ...where,
                is_published: filter.is_published,
            };
            }
            



      if (filter.stones_used) {
        const searchTerms = filter.stones_used.split('|');

        include = [
          {
            model: db.stones,
            as: 'stones_used_filter',
            required: searchTerms.length > 0,
            where: searchTerms.length > 0 ? {
              [Op.or]: [
                { id: { [Op.in]: searchTerms.map(term => Utils.uuid(term)) } },
                { 
                  name_ar: {
                    [Op.or]: searchTerms.map(term => ({ [Op.iLike]: `%${term}%` }))
                  }
                }
              ]
            } : undefined
          },
          ...include,
        ]
      }

      if (filter.applications) {
        const searchTerms = filter.applications.split('|');

        include = [
          {
            model: db.applications,
            as: 'applications_filter',
            required: searchTerms.length > 0,
            where: searchTerms.length > 0 ? {
              [Op.or]: [
                { id: { [Op.in]: searchTerms.map(term => Utils.uuid(term)) } },
                { 
                  name_ar: {
                    [Op.or]: searchTerms.map(term => ({ [Op.iLike]: `%${term}%` }))
                  }
                }
              ]
            } : undefined
          },
          ...include,
        ]
      }


            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.projects.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'projects',
                        'name_ar',
                        query,
                    ),
                ],
            };
        }

        const records = await db.projects.findAll({
            attributes: [ 'id', 'name_ar' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name_ar', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name_ar,
        }));
    }

    
};

